#include <SDL.h>
#include <time.h>
#include <unistd.h>

#define H 480
#define W 640

SDL_Renderer* renderer;

/* Dessine un pixel de couleur (r, g, b) au point de coordonnées (x, y) sur l'écran. */
void draw_pixel(int x, int y, unsigned char r,unsigned char  g,unsigned char  b){
	SDL_SetRenderDrawColor(renderer, r, g, b, 255);
	SDL_RenderDrawPoint(renderer, x, y);
}


int main(){
	if (SDL_Init(SDL_INIT_VIDEO) != 0){
		printf("Erreur d'initialisation: %s\n", SDL_GetError());
		exit(1);
	}
	SDL_Window* window = SDL_CreateWindow("Hello SDL", SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED, W, H, 0);
	if (window == NULL){
		printf("Erreur de création de la fenêtre: %s\n", SDL_GetError());
		exit(1);
	}

	renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
	if (renderer == NULL){
		printf("Erreur de création du renderer: %s\n", SDL_GetError());
		exit(1);
	}



	/* Exemple 1: dessiner un gradient de couleur et l'afficher à l'écran

	Les deux boucles placent des pixels de couleurs variant légèrement selon
	la position

	 */

	SDL_RenderClear(renderer); // efface le dessin actuel
	SDL_SetRenderDrawColor(renderer, 200, 170, 221, 255); // fixe la couleur de base du moteur de rendu (pas utile pour cet exemple)
	for (int i = 0; i < H; i++)
	{
		for (int j = 0; j < W; j++){
			// les quantités de rouge, vert et bleu varient linéairement selon
			// la position
			draw_pixel(j, i, 100-0.04*(i+j), 0.07*(i+0.2*j), 0.03*(j+0.4*i));
		}
	}

	// Afficher le dessin
	// Sans la ligne suivante, le dessin actuel n'est pas affiché sur la fenêtre
	SDL_RenderPresent(renderer);

	// Attendre 5 secondes
	sleep(5);

	// Terminer le programme
	SDL_DestroyWindow(window);
	SDL_Quit();

	return 0;
}